
#####################
#####Multiple Comparison for Multivariate normal Based on Univariate Composte Likelihood
######################
######################Normal with unstructured covariance setting


library(mvtnorm)
set.seed(123466)
m    <-  4 
p    <-  10
n    <-  200
B    <-  10

#Covariance matrix  for m=10

#library(clusterGeneration)
#sigma_true<- genPositiveDefMat("eigen",dim=m)$Sigma

# sig       <-  array(dim=c(m,m))
# sig[m,m]  <-  sample(seq(0.5,3,0.2),1)
#
# for (i in 1:(m-1)){
#   sig[i,i]        <- sample(seq(0.5,3,0.2),1)
#   sig[i,(i+1):m]  <- sample(seq(0.1,2,0.2),(m-i))
#   sig[(i+1):m,i]  <- sig[i,(i+1):m]
# }
# sigma_true        <- sig


#Covariance matrix  for m=4

sig <- c(1.3, 0.9, 0.5, 0.3,0.9, 1.9, 1.3 , 0.3,0.5 ,1.3,1.3, 0.1,0.3,0.3,0.1,0.7)
sigma_true <- matrix(sig, nrow=4)
# [,1] [,2] [,3] [,4]
# [1,]  1.3  0.9  0.5  0.3
# [2,]  0.9  1.9  1.3  0.3
# [3,]  0.5  1.3  1.3  0.1
# [4,]  0.3  0.3  0.1  0.7


#true_beta <- rep(0,p)
#true_beta <- c(0,0,0,0.035,rep(0,(p-4)))   
true_beta <- c(0,0.01,0.01,-0.03,0.005, -0.01,rep(0,(p-6)))

sM   <-  rep(0,B)
sB   <-  rep(0,B)
sT   <-  rep(0,B)
sD   <-  rep(0,B)
sH   <-  rep(0,B)
sS   <-  rep(0,B)
sN   <-  rep(0,B)
 
Mm   <-  rep(0,B)
Bb   <-  rep(0,B)
Tt   <-  rep(0,B)
Dd   <-  rep(0,B)
Hh   <-  rep(0,B)
Ss   <-  rep(0,B)
Nn   <-  rep(0,B)

##many to one comparisons
if (p==10){
  C <- rbind(c(-1, 1, rep(0,8)),
             c(-1, 0, 1,rep(0,7)),
             c(-1, 0, 0, 1,rep(0,6)),
             c(-1, 0, 0, 0, 1,rep(0,5)),
             c(-1, 0, 0, 0, 0, 1,rep(0,4)),
             c(-1, 0, 0, 0, 0, 0, 1,rep(0,3)),
             c(-1, 0, 0, 0, 0, 0, 0, 1,rep(0,2)),
             c(-1, rep(0,7), 1, 0),
             c(-1, rep(0,8), 1))
  
}else if (p==20){
  
  
  C <- rbind(c(-1, 1, rep(0,18)),
             c(-1, 0, 1,rep(0,17)),
             c(-1, 0, 0, 1,rep(0,16)),
             c(-1, 0, 0, 0, 1,rep(0,15)),
             c(-1, 0, 0, 0, 0, 1,rep(0,14)),
             c(-1, 0, 0, 0, 0, 0, 1,rep(0,13)),
             c(-1, 0, 0, 0, 0, 0, 0, 1,rep(0,12)),
             c(-1, rep(0,7), 1, rep(0,11)),
             c(-1, rep(0,8), 1, rep(0,10)),
             c(-1, rep(0,9), 1, rep(0,9)),
             c(-1, rep(0,10), 1, rep(0,8)),
             c(-1, rep(0,11), 1, rep(0,7)),
             c(-1, rep(0,12), 1, rep(0,6)),
             c(-1, rep(0,13), 1, rep(0,5)),
             c(-1, rep(0,14), 1, rep(0,4)),
             c(-1, rep(0,15), 1, rep(0,3)),
             c(-1, rep(0,16), 1, rep(0,2)),
             c(-1, rep(0,17), 1, 0),
             c(-1, rep(0,18), 1))
}

C   <-  t(C)
##all pairwise comparisons
#   C <- matrix(0,nrow=p,ncol=p*(p-1)/2)
#   comb <- combn(p,2)
#   C[cbind(comb[1,],1:(p*(p-1)/2))] <- 1
#   C[cbind(comb[2,],1:(p*(p-1)/2))] <- -1


seed <- sample(seq(1111111,99956999,24),B)


for(b in 1:B){
  set.seed(seed[b])
  desx      <- array(dim=c(m,p,n))
  y         <- matrix(0,nrow=m,ncol=n)
  mu        <- array(dim=c(m,1,n))
  
  # Generating n families of size m from m-variate normal
  for (k in 1:n){
    
    for(j in 1:p){
      l          <-  sample(seq(-3,3,0.5),1)
      v          <-  sample(seq(3,6,0.6),1)
      desx[,j,k] <-  rnorm(m,l,v)

    }
    mu[,,k]      <-  desx[,,k] %*% true_beta
    y[,k]        <-  mvrnorm(1,mu[,,k], sigma_true, tol = 1e-6, empirical = FALSE)
  }
  
  #Estimating beta and sigma from marginal normal log likelihood
  beta_hat   <-  rep(1,p)
  W          <-  diag(sample(seq(2,15,1),m))
  
  for(h in 1:100){
    
    beta_hat_new   <-  beta_hat
    p1             <-  matrix(0,nrow=p,ncol=p)
    p2             <-  matrix(0,nrow=p,ncol=1)
    
    for (i in 1:n){
      p1           <-  p1 + t(desx[,,i])%*%W%*%desx[,,i]
      p2           <-  p2 + t(desx[,,i])%*%W%*%y[,i]
    }
    
    beta_hat_new   <-  solve(p1) %*%p2
    
    
    e              <-  matrix(0,nrow=m,ncol=n)
    
    for ( i in 1:n){
      e[,i]       <-  y[,i]-desx[,,i] %*% beta_hat_new
    }
    
    sii           <-  rep(0,m)
    
    for (j in 1:m){
      sii[j]      <-  (t(e[j,])%*%e[j,])/(n-p)
    }
    
    W   <-  diag(1/sii)
    H   <-  matrix(0, nrow=p,ncol=p)
    S   <-  matrix(0, nrow=p,ncol=1)
    
    for (i in 1:n){
      H    <-   H + t(desx[,,i])%*%W%*%desx[,,i]
      S    <-   S + t(desx[,,i])%*%W%*%(y[,i]-(desx[,,i]%*%beta_hat_new))
    }
    
    beta_hat  <-  ifelse(abs(solve(H)%*%S) < 10^(-5),beta_hat_new,beta_hat_new- solve(H)%*%S)
    if (all(beta_hat == beta_hat_new)){break}
    print(h)
  }
  
  yhat      <- matrix(0,nrow=m,ncol=n)
  e         <- matrix(0,nrow=m,ncol=n)
  
  for ( i in 1:n){
    yhat[,i] <- desx[,,i] %*% beta_hat
    e[,i]    <- y[,i]-yhat[,i]
  }
  
  sij <-array(dim=c(m,m))
  
  for (j in 1:(m-1)){
    sij[j,j]      <-   (t(e[j,])%*%e[j,])/(n-p)
    for(i in (j+1):m){
      sij[j,i]    <-   (t(e[j,])%*%e[i,])/(n-p)
      sij[i,j]    <-   sij[j,i]
    }  
  }
  sij[m,m]        <-  (t(e[m,])%*%e[m,])/(n-p)
  Sigma_hat       <-   sij
  naive_sigma_hat <-   diag(Sigma_hat)*diag(m)
  sii_naive       <-   sum(apply(e,1,function(x)sum(x^2)))/(n*m)
  W               <-   diag(1/diag( Sigma_hat ))
  ############################
  
  # Computing the cov(beta_hat)
  c1       <-  matrix(0,nrow=p,ncol=p)
  c2       <-  matrix(0,nrow=p,ncol=p)
  naive_c2 <-  matrix(0,nrow=p,ncol=p)
  
  for(i in 1:n){
    c1      <-  c1 +(t(desx[,,i])%*%W%*%desx[,,i])
    c2      <-  c2 +t(desx[,,i])%*%W%*%Sigma_hat%*%W%*%desx[,,i]
    naive_c2<-  naive_c2 +t(desx[,,i])%*%W%*%naive_sigma_hat%*%W%*%desx[,,i]#??????????????
  }
  
  Cov_beta  <-  solve(c1)%*%c2 %*%t(solve(c1))

  
  
  
  bstr     <-  t(C)%*%beta_hat
  cov_str  <-  t(C)%*%Cov_beta%*%C
  se_str   <-  diag(cov_str)^(-1/2)
  v_mat    <-  diag(se_str)    
  
  ################Cov(T), T=cb/c*sig*c'
  T        <-  bstr*se_str
  cov_T    <-  v_mat%*%cov_str%*%t(v_mat)
  
  qu   	   <- 	qmvnorm(0.95, tail ="both.tails", mean = 0,  corr=cov_T)
  quantile <- 	qu$quantile
  sM[b] 	 <- 	sum(abs(T)<quantile)
  Mm[b]    <-   as.numeric(abs(T)[1,]<quantile)+ as.numeric(abs(T)[2,]<quantile)+ as.numeric(abs(T)[3,]<quantile)+ as.numeric(abs(T)[4,]<quantile)+ as.numeric(abs(T)[5,]<quantile)
  
  ###	Bonferroni  
  
  Bon 	   <- 	0.05/ncol(C)
  qBon 	   <- 	qnorm(1-Bon/2)  
  sB[b]    <-   sum(abs(T)<qBon)
  Bb[b]    <-   as.numeric(abs(T)[1,]<qBon)+ as.numeric(abs(T)[2,]<qBon)+ as.numeric(abs(T)[3,]<qBon)+ as.numeric(abs(T)[4,]<qBon)+ as.numeric(abs(T)[5,]<qBon)
  
  ###	Dunn-Sidak
  
  dunn 		 <- 	1-(1-0.05)^(1/ncol(C))
  qDunn 	 <- 	qnorm(1-dunn/2)  
  sD[b]    <-   sum(abs(T)<qDunn)
  Dd[b]    <-   as.numeric(abs(T)[1,]<qDunn)+ as.numeric(abs(T)[2,]<qDunn)+ as.numeric(abs(T)[3,]<qDunn)+ as.numeric(abs(T)[4,]<qDunn)+ as.numeric(abs(T)[5,]<qDunn)
  
  ###	Holm
  
  t_h 		 <- 	sort(abs(T),decreasing=TRUE)
  Holm 		 <- 	0.05/(ncol(C)-c(1:ncol(C))+1)
  qHolm 	 <- 	qnorm(1-Holm/2) 
  sH[b]    <-   sum(t_h< qHolm)
  Hh[b]    <-   as.numeric(abs(T)[1,]<qHolm[1])+ as.numeric(abs(T)[2,]<qHolm[2])+ as.numeric(abs(T)[3,]<qHolm[3])+ as.numeric(abs(T)[4,]<qHolm[4])+ as.numeric(abs(T)[5,]<qHolm[5])
  
  ### Scheffe
  
  qscheffe  <-  sqrt(qchisq(0.95,(p-1)))  
  sS[b]     <-  sum(abs(T)< qscheffe )
  Ss[b]     <-  as.numeric(abs(T)[1,]<qscheffe)+ as.numeric(abs(T)[2,]<qscheffe)+ as.numeric(abs(T)[3,]<qscheffe)+ as.numeric(abs(T)[4,]<qscheffe)+ as.numeric(abs(T)[5,]<qscheffe)
  
  ### Tukey
  
  qtuk     <-  qtukey(0.05,p,(m*n-p),lower.tail = F)/sqrt(2)  
  sT[b]    <-  sum( abs(T)< qtuk)
  Tt[b]    <-  as.numeric(abs(T)[1,]<qtuk)+ as.numeric(abs(T)[2,]<qtuk)+ as.numeric(abs(T)[3,]<qtuk)+ as.numeric(abs(T)[4,]<qtuk)+ as.numeric(abs(T)[5,]<qtuk)
  
  ### naive
  
  Cov_beta_naive2 <-  solve(c1)%*%naive_c2%*%t(solve(c1))
  cov_str_naive2  <-  t(C)%*%Cov_beta_naive2 %*%C
  se_str_naive2   <-  diag(cov_str_naive2)^(-1/2)
  v_mat_n2        <-  diag(se_str_naive2)
  
  T_n             <-  bstr*se_str_naive2
  cov_T_naive2    <-  v_mat_n2%*%cov_str_naive2%*%t(v_mat_n2)  
  
  qu_n2           <-  qmvnorm(0.95, tail ="both.tails", mean = 0,  sigma=cov_T_naive2 )####Simultaneous quantile
  quantile_naive  <-  qu_n2$quantile
  sN[b]           <- 	sum(abs(T_n)<quantile_naive)
  Nn[b]           <-  as.numeric(abs(T_n)[1,]<quantile_naive)+ as.numeric(abs(T_n)[2,]<quantile_naive)+ as.numeric(abs(T_n)[3,]<quantile_naive)+ as.numeric(abs(T_n)[4,]<quantile_naive)+ as.numeric(abs(T_n)[5,]<quantile_naive)
  
  #print(b)
  answ1<-c(paste("m",m,"p",p),"MNQ",sM[b],"Naive", sN[b], "Bon" ,sB[b],"Sidak",sD[b],"Holm",sH[b], "Scheffe",sS[b],"Tukey", sT[b])
  write.table(answ1 ,file= paste("F://normUnPower/NormUnPowA", m,p, ".txt"),append=TRUE,row.names=FALSE,col.names=FALSE,sep=" ",eol = "\n")
 
  
  answ2<- c(paste("m",m,"p",p),"MNQ",Mm[b],"Naive", Nn[b], "Bon" ,Bb[b],"Sidak",Dd[b],"Holm",Hh[b], "Scheffe",Ss[b],"Tukey", Tt[b])
  write.table(answ2 ,file= paste("F://normUnPower/NormUnPowA2", m,p, ".txt"),append=TRUE,row.names=FALSE,col.names=FALSE,sep=" ",eol = "\n")
  
  
  
  print(b)
} 

