########################################
######################Using Composite likelihood in Multiple comparisn
############################
##########################Gamma distribution

library(mvtnorm)
set.seed(223344)

p <- 3
n <- 3000
m <- 10

B    <- 10000

sM <-rep(0,B)
sB <-rep(0,B)
sT <-rep(0,B)
sD <-rep(0,B)
sH <-rep(0,B)
sS <-rep(0,B)
sN <-rep(0,B)



C <- rbind(c(-1, 1, rep(0,8)),
           c(-1, 0, 1,rep(0,7)),
           c(-1, 0, 0, 1,rep(0,6)),
           c(-1, 0, 0, 0, 1,rep(0,5)),
           c(-1, 0, 0, 0, 0, 1,rep(0,4)),
           c(-1, 0, 0, 0, 0, 0, 1,rep(0,3)),
           c(-1, 0, 0, 0, 0, 0, 0, 1,rep(0,2)),
           c(-1, rep(0,7), 1, 0),
           c(-1, rep(0,8), 1))



C   <-  t(C)


seed <- sample(seq(1111111,99956999,24),B)

T1 <- diag(1,nrow=m)
#T1<-matrix(c(1,1,0,1,0,1,0,1,1),byrow=FALSE,nrow=3)

#true_beta <- c(0.2,0.175,0.185,0.2,0.21,0.2,0.2,0.19,0.2,0.2)



for (b in 1:B){
  set.seed(seed[b])
  
  x      <- array(dim=c(m,p,n))
  y         <- matrix(0,nrow=m,ncol=n)
  G         <- matrix(0,nrow=m,ncol=n)
  mu_mult        <- array(dim=c(m,n))
  mu_marg        <- array(dim=c(m,n))
  for (  j in 1: n){
    for ( i in 1: p){
      
      
      z1 <- rgamma(1,0.1)
      x[,i,j] <-c(z1,1.1*z1,1.12*z1)
    }
  }
  
  a <- 0.5
  bet <- rep(0.75,p)
  
  for ( i in 1:n){
    mu_mult[,i] <-   exp(a + x[,,i]%*%bet) 
    mu_marg[,i] <- solve(T1)%*%mu_mult[,i]
   
    shape <- 1
    G[,i] <- rgamma(m, rate = shape /mu_marg[,i], shape = shape)
    y[,i]<-  T1%*%G[,i] 
    
  }
  
  which(mu_marg<=0)
  
  yy<- rep(0,n*m)
  for( i in 1:(n)){
    yy[((i-1)*m+1):(i*m)] <- y[,i]
  }
  xx<- matrix(0,nrow=m*n, ncol=p)
  data <- data.frame(xx,yy)
  for( i in 1:(n)){
    xx[((i-1)*m+1):(i*m),] <- x[,,i]
  }
  
  m_glm <- glm(yy ~ xx, family = Gamma(link = "log"))
  beta_hat <- as.vector(m_glm$coefficients[-1])
  beta_hat 
  a_hat <- (m_glm$coefficients[1])
  summary(m_glm) 
  
  
  ####Deviance / dispersion parameter
  
  e         <-   matrix(0,nrow=m,ncol=n)
  Dev         <-   matrix(0,nrow=m,ncol=n)
  dd  <-   matrix(0,nrow=m,ncol=n)
  for ( i in 1:n){
    mu_h <-    exp(a_hat+ x[,,i] %*% beta_hat)
    e[,i]      <-   y[,i]-mu_h        
    
    Dev[,i] <-  2*((y[,i]-mu_h)/mu_h + log(mu_h/y[,i]))  
    dd[,i] <- ((y[,i]-mu_h)/mu_h )^2
  }
  
  Deviance <- sum(apply(Dev,1,sum))/(m*n-p)
  dispersion <- Deviance*(6*(n*m-p)+n*m*Deviance)/(6*(n*m-p)+2*n*m*Deviance)

  
  H <- matrix(0,p,p)
  J <- matrix(0,p,p)
  
  for( i in 1: n){   
    
    dmu <-  as.vector(exp(a_hat+ x[,,i] %*% beta_hat))*x[,,i] 
    mu_h <-  exp(a_hat+ x[,,i] %*% beta_hat)
    
    V <- diag(as.vector(dispersion*mu_h^2))
    H <- H + t(dmu)%*%solve(V)%*%(dmu)
    
    sij  <-(y[,i]-mu_h)%*%t(y[,i]-mu_h)
    
    J <- J + t(dmu)%*%solve(V)%*%sij%*%solve(V)%*%dmu   
    
  }
  
  Cov_beta <- solve(H)%*%J%*%t(solve(H))
  
  ### Test statistic
  
  bstr    <-   t(C)%*%(beta_hat - bet )
  cov_str 	<- 	t(C)%*%Cov_beta%*%C
  se_str 	<- 	diag(cov_str)^(-1/2)
  v_mat  	<- 	diag(se_str)  
  
  
  T 		<- 	bstr*se_str
  cov_T 	<- 	v_mat%*%cov_str%*%t(v_mat)  
  
  ###	MNQ
  
  qu 		<- 	qmvnorm(0.95, tail ="both.tails", mean = 0,  corr=cov_T)
  quantile  <- 	qu$quantile
  sM[b] 	<- 	sum(abs(T)<quantile)
  
  ###  Naive method: ignoring dependence structure
  
  Cov_bata_naive	 <-  solve(H)
  
  cov_str_naive  	 <- 	t(C)%*%Cov_bata_naive %*%C
  se_str_naive 	 <- 	diag(cov_str_naive)^(-1/2)
  v_mat_n  		 <- 	diag(se_str_naive)
  corr_beta_naive  <-   v_mat_n %*% cov_str_naive %*% v_mat_n
  qu_n 		 <- 	qmvnorm(0.95, tail ="both.tails", mean = 0,  sigma= corr_beta_naive)####Simultaneous quantile
  quantile_naive 	 <- 	qu_n$quantile
  
  T_n 		 <- 	bstr*se_str_naive
  sN[b] 	 <- 	sum(abs(T_n)<quantile_naive)
  
   ##  Bonferroni  
  
  Bon 	<- 	0.05/ncol(C)
  qBon 	<- 	qnorm(1-Bon/2)  
  sB[b]    <- sum(abs(T)<qBon)
  
  ###	Dunn-Sidak
  
  dunn 		 <- 	1-(1-0.05)^(1/ncol(C))
  qDunn 		 <- 	qnorm(1-dunn/2)  
  sD[b] <- sum(abs(T)<qDunn)
  
  ###	Holm
  
  t_h 		 <- 	sort(abs(T),decreasing=TRUE)
  Holm 		 <- 	0.05/(ncol(C)-c(1:ncol(C))+1)
  qHolm 		 <- 	qnorm(1-Holm/2) 
  sH[b]         <-  sum(t_h< qHolm)
  
  
  ### Scheffe
  
  qscheffe  <- sqrt(qchisq(0.95,(p-1)))  
  sS[b] <- sum(abs(T)< qscheffe )
  
  ### Tukey
  
  qtuk     <- qtukey(0.05,p,(m*n-p),lower.tail = F)/sqrt(2)  
  sT[b]       <- sum( abs(T)< qtuk)
  

  answ1<-c(paste("m",m,"p",p),"MNQ",sM[b],"Naive", sN[b], "Bon" ,sB[b],"Sidak",sD[b],"Holm",sH[b], "Scheffe",sS[b],"Tukey", sT[b])
  write.table(answ1 ,file=paste("d://gammaa",m,p,".txt"),append=TRUE ,row.names=FALSE,col.names=FALSE,sep=" ",eol = "\n")
  #cat(answ1 ,file=paste("QETEST2",m,p,w,".txt"),sep="\n",append=TRUE)
  
  
  print(b)
  
}  

